/* Shortcut Launcher v1.0
 *
 * 
 * Copyright (C) 2006 BoxiT Software.
 *
 * UserInterface.js
 *
 * Requires Yahoo! Widget Engine 3 or later
 */
var maxPages = 0;
var curPage = 0;
var maxIcons = 0;
var maxTextItems = 11;

function displayShortcuts (shortcutItems, viewType) {
	
	var categories = getCategories();
	 
	if (shortcutItems == null)
	{
		// No shortcut items, put in a little image to reflect this
		noShortcuts.visible = true;
		return;
	} else{
		// If there are shortcuts then we need to make sure the image is hidden
		noShortcuts.visible = false;
	}
		
	// Set the initial icon offsets
	var imgvOffset = 4;
	var imghOffset = 8;
	var iconSize = parseInt(preferences.iconSize.value);
	
	// Set the initial text offsets
	var txthOffset = 4;
	var txtvOffset = 14;
	
	// Set the initial offsets for Icon & Text display
	var icoTxthOffset = 22;
	var icoTxtvOffset = 14;
	var icoImghOffset = 4;
	var icoImgvOffset = 2;
	
	// We need to set the max number to control the loop based on the viewType
	switch(viewType)
	{
		case 'Icons':
			var maxItems = maxIcons;
			break;
		case "Text":
			var maxItems = maxTextItems;
			break;
		case "Icon & Text":
			var maxItems = maxTextItems;
			break;
	}
	
	// Loop through the shortcut collection
	for (n = 0; n < maxItems; n++)
	{
		scutItem = (curPage * maxItems) + n;
				
		// Get the relevant info from the shortcut
		var strPath = shortcutItems[scutItem].path;
		var strTitle = shortcutItems[scutItem].title;
			
		// Display the shortcut according to the viewType
		switch(viewType)
		{
			case "Text":
				var shortcut = new Text();
				
				shortcut.data = strTitle;
				shortcut.hOffset = txthOffset;
				shortcut.vOffset = txtvOffset;
				// We need to increase the vOffset so that each shortcut goes on a new line
				txtvOffset += 16;
				if (parseInt(preferences.fontShadow.value) == 1)
				{
					var s = new Shadow();
					s.hOffset = 1;
					s.vOffset = 1;
					s.color = preferences.fontShadowColour.value;
					shortcut.shadow = s;
				}
				shortcut.color = preferences.fontColour.value;
				shortcut.font = preferences.fontName.value;
				shortcut.size = 12;
				//shortcut.width = 262;
				shortcut.onMouseEnter = "highlightText(" + (txthOffset - 2) + ", " + (txtvOffset - 3) + ", 1);";
				shortcut.onMouseExit = "highlightText(0, 0, 0);";
				break;
			case "Icons":
				var shortcut = new Image();
				shortcut.name = scutItem;	// We use n as name so we can find the correct shortcut in the array on actions
				if (strPath.substr(0, 4) == "http")
				{
					shortcut.src = "Resources/images/WebPage.png";
				} else{
					shortcut.src = strPath;
					shortcut.useFileIcon = 1;
				}
				shortcut.hOffset = imghOffset;
				shortcut.vOffset = imgvOffset;
				shortcut.height = iconSize;
				shortcut.width = iconSize;
				shortcut.tooltip = strTitle;
				shortcut.onMouseEnter = "highlightIcon(" + (imghOffset - 2)  + ", " + (imgvOffset + 22) + ", " + (iconSize + 4) + ", 1);";
				shortcut.onMouseExit = "highlightIcon(0, 0, " + iconSize + ", 0);";
				if ((imghOffset + (iconSize + 4)) >= 170)
				{
					imghOffset = 8;
					imgvOffset += (iconSize + 4);
				}
				else {
					imghOffset += (iconSize + 4);
				}	
				break;
			case "Icon & Text":
				// The clickable element in this case will be the text
				var shortcut = new Text();
				
				shortcut.data = strTitle;
				shortcut.hOffset = icoTxthOffset;
				shortcut.vOffset = icoTxtvOffset;
				// We need to increase the vOffset so that each shortcut goes on a new line
				icoTxtvOffset += 16;
				if (parseInt(preferences.fontShadow.value) == 1)
				{
					var s = new Shadow();
					s.hOffset = 1;
					s.vOffset = 1;
					s.color = preferences.fontShadowColour.value;
					shortcut.shadow = s;
				}
				shortcut.color = preferences.fontColour.value;
				shortcut.font = preferences.fontName.value;
				shortcut.size = 12;
				//shortcut.width = 240;
				shortcut.onMouseEnter = "highlightText(" + (icoTxthOffset - 20) + ", " + (icoTxtvOffset - 4) + ", 1);";
				shortcut.onMouseExit = "highlightText(0, 0, 0);";
				
				// Create the image
				var txtImage = new Image();
				if (strPath.substr(0, 4) == "http")
				{
					txtImage.src = "Resources/images/WebPage.png";
				} else{
					txtImage.src = strPath;
					txtImage.useFileIcon = 1;
				}
				txtImage.hOffset = icoImghOffset;
				txtImage.vOffset = icoImgvOffset;
				txtImage.height = 16;
				txtImage.width = 16;
				icoImgvOffset += 16;
				shortcutList.addSubview(txtImage);
				break;
		}
		
		// Prepare the context menu items
		var menuItems = Array();
		menuItems[0] = new MenuItem();
		menuItems[0].title = "Launch Shortcut...";
		menuItems[0].onSelect = "shortcutMouseDown(" + scutItem + ");";
		
		menuItems[1] = new MenuItem();
		menuItems[1].title = "Remove Shortcut...";
		menuItems[1].onSelect = "removeShortcut(" + scutItem + ");";
		
		menuItems[2] = new MenuItem();
		menuItems[2].title = "Edit Shortcut Properties...";
		menuItems[2].onSelect = "editShortcutProperties(" + scutItem + ");";
			
		// Add the actions to the shortcut then add to the list view
		shortcut.contextMenuItems = menuItems;
		shortcut.onMouseUp = "shortcutMouseDown(" + scutItem + ");";
		shortcutList.addSubview(shortcut);
		
		// We need to check to see if we should go round again
		if (scutItem == shortcutItems.length - 1)
		{
			n = maxItems;
		}
	}
}

function clearShortcutList()
{
	// Get the items from the list.. if any!
	var existingItems = Array();
	existingItems = shortcutList.subviews;
	
	// If the existingItems variable is not null then we can do something
	if (existingItems != null)
	{
		// Items exist so they can be removed
		for (i = 0; i < existingItems.length; i++)
		{
			existingItems[i].removeFromSuperview();
		}
	} else{
		// There are no items in the frame so we return having done nothing
		return;
	}
}

function showListViewContext()
{
	var items = generateListViewMenu();		
	shortcutList.contextMenuItems = items;
}

function showListViewMenu()
{
	var items = generateListViewMenu();		
	popupMenu(items, system.event.hOffset, system.event.vOffset);
}

function generateListViewMenu()
{
	// First we need to create the menu items to display
	var items = Array();
	
	items[0] = new MenuItem();
	items[0].title = "Add New Shortcut (File)";
	items[0].onSelect = "addNewShortcut('File');";
	
	items[1] = new MenuItem();
	items[1].title = "Add New Shortcut (Web)";
	items[1].onSelect = "addNewShortcut('Web');";
	
	items[2] = new MenuItem();
	items[2].title = "-";
	
	items[3] = new MenuItem();
	items[3].title = "Add New Category";
	items[3].onSelect = "manageCategories('Add');";
	
	items[4] = new MenuItem();
	items[4].title = "Remove Category";
	items[4].onSelect = "manageCategories('Remove');";
	
	items[5] = new MenuItem();
	items[5].title = "-";
	
	var i = 0;
	
	// Loop through the categories variable and add them as menu items
	var categories = getCategories();
	
	if (categories == null)
	{
		items[6] = new MenuItem();
		items[6].title = "No Categories";
		items[6].enabled = false;	
	} else{
		items[6] = new MenuItem();
		items[6].title = "All Shortcuts";
		items[6].onSelect = "changeCategory('All Shortcuts');";
		if (preferences.currentCategory.value == "All Shortcuts")
		{
			items[6].checked = true;
		} else{
			items[6].checked = false;
		}
		
		for (i = 0; i < categories.length; i++)
		{
			if (categories[i] != undefined)
			{
				items[i + 7] = new MenuItem();
				items[i + 7].title = categories[i];
				items[i + 7].onSelect = "changeCategory('" + categories[i] + "');";
				if (categories[i] == preferences.currentCategory.value)
				{
					items[i + 7].checked = true;
				} else{
					items[i + 7].checked = false;
				}
			}
		}
	}
	
	items[i + 8] = new MenuItem();
	items[i + 8].title = "-";
	
	items[i + 9] = new MenuItem();
	items[i + 9].title = "Display Icons";
	items[i + 9].onSelect = "switchDisplay('Icons');";
	if (preferences.viewType.value == "Icons")
	{
		items[i + 9].checked = true;
	} else{
		items[i + 9].checked = false;
	} 
	
	items[i + 10] = new MenuItem();
	items[i + 10].title = "Display Text";
	items[i + 10].onSelect = "switchDisplay('Text');";
	if (preferences.viewType.value == "Text")
	{
		items[i + 10].checked = true;
	} else{
		items[i + 10].checked = false;
	}
	
	items[i + 11] = new MenuItem();
	items[i + 11].title = "Display Text & Icons";
	items[i + 11].onSelect = "switchDisplay('Icon & Text');";
	if (preferences.viewType.value == "Icon & Text")
	{
		items[i + 11].checked = true;
	} else{
		items[i + 11].checked = false;
	}
	
	return items;
}

function switchDisplay(viewType)
{
	preferences.viewType.value = viewType;
	updatePageDisplay();
}

function highlightText(hOffset, vOffset, visible)
{
	txtHighlight.hOffset = hOffset;
	txtHighlight.vOffset = vOffset;
	txtHighlight.visible = visible;
	txtHighlight.colorize = preferences.highlightColour.value;
}

function highlightIcon(hOffset, vOffset, size, visible)
{
	iconHighlight.hOffset = hOffset;
	iconHighlight.vOffset = vOffset;
	iconHighlight.width = size;
	iconHighlight.height = size;
	iconHighlight.visible = visible;
	iconHighlight.colorize = preferences.highlightColour.value;
}

function changePageButton(direction)
{
	switch(direction)
	{
		case 'forward':
			if ((curPage + 1) != maxPages)
			{
				curPage++;
				updatePageDisplay();
			} else{
				return;
			}
			break;
		case 'back':
			if (curPage != 0)
			{
				curPage--;
				updatePageDisplay();
			} else{
				return;
			}
			break;
		}
}

function updatePageDisplay()
{
	//Clear the current list contents if any
	clearShortcutList();
	
	// Get the currently set category for display
	var category = preferences.currentCategory.value;
	
	// Get the currently set view typw
	var viewType = preferences.viewType.value;
	
	// Populate an array of shortcut items
	var shortcutItems = getShortcuts(category);
	
	// Check if the category is set to display in the title bar
	if (preferences.categoryInTitle.value == true)
	{
		windowTitle.data = preferences.currentCategory.value;
		if(preferences.currentCategory.value == "empty")
		{
			windowTitle.data = "Shortcut Launcher";
		}
	}else{
		windowTitle.data = "Shortcut Launcher";
	}
	
	// Are there any shortcut items?
	if (shortcutItems == null)
	{
		noShortcuts.visible = true;
		return;	
	} else{
		// Switch off the no shortcuts image
		noShortcuts.visible = false;
	}
	
	// Calculate the page requirements based on the view type
	switch(viewType)
	{
		case "Text":
			maxPages = Math.ceil(shortcutItems.length / maxTextItems);
			displayShortcuts(shortcutItems, viewType);
			break;
		case "Icons":
			var iconSize = parseInt(preferences.iconSize.value);
	
			// Set the number of icons per page based on icon size
			switch (iconSize)
			{
				case 16:
					maxIcons = 81;
					break;
				case 24:
					maxIcons = 36;
					break;
				case 32:
					maxIcons = 25;
					break;	
			}
			
			maxPages = Math.ceil(shortcutItems.length / maxIcons);
			displayShortcuts(shortcutItems, viewType);
			break;
		case "Icon & Text":
			maxPages = Math.ceil(shortcutItems.length / maxTextItems);
			displayShortcuts(shortcutItems, viewType);
			break;
	}
	
	// Change the text to report page numbers
	updatePageButtons();
}

function updatePageButtons()
{
	if (maxPages > 1)
	{
		pageCount.data = "Page " + (curPage + 1) + " of " + maxPages;
		pageCount.visible = true;
		pageForwardButton.visible = true;
		pageBackButton.visible = true;
	} else{
		pageCount.visible = false;
		pageForwardButton.visible = false;
		pageBackButton.visible = false;
	}
	
	if((curPage + 1) == maxPages)
	{
		pageForwardButton.visible = false;
	} 
	
	if(curPage == 0)
	{
		pageBackButton.visible = false;
	} 
}

function categorySelector(strDescription, strTitle, strOKButton)
{
	// This will display a form with a category list for the user to select a category
	
	// Get the categories list
	var categories = getCategories();
	
	// Create the forms field
	var formFields = Array();
	
	formFields[0] = new FormField();
	formFields[0].name = "popCategory";
	formFields[0].type = "popup";
	formFields[0].option = categories;
	formFields[0].title = "Category:";
	formFields[0].description = strDescription;
	
	// Display the form			
	formResults = form(formFields, strTitle, strOKButton, "Cancel");
	
	// Process the results of the form and return either the category or null
	if (formResults != null)
	{
		return formResults[0];
	} else{
		return null;
	}
}

function selectCategoryMenu()
{
	// Get the categories available
	var categories = getCategories();
	
	if (categories != null)
	{
		var menuItems = Array();
		
		menuItems[0] = new MenuItem();
		menuItems[0].title = "All Shortcuts";
		menuItems[0].onSelect = "changeCategory('All Shortcuts');";
		if (preferences.currentCategory.value == "All Shortcuts")
		{
			menuItems[0].checked = true;
		} else{
			menuItems[0].checked = false;
		}
		
		for (i = 0; i < categories.length; i++)
		{
			menuItems[i + 1] = new MenuItem();
			menuItems[i + 1].title = categories[i];
			menuItems[i + 1].onSelect = "changeCategory('" + categories[i] + "');";
			if (categories[i] == preferences.currentCategory.value)
			{
				menuItems[i + 1].checked = true;
			} else{
				menuItems[i + 1].checked = false;
			}
		}
		
		popupMenu(menuItems, windowTitle.hOffset, windowTitle.vOffset + 2);
	}else{
		var menuItems = Array();
		
		menuItems[0] = new MenuItem();
		menuItems[0].title = "No Categories Available";
		menuItems[0].enabled = false;
		
		popupMenu(menuItems, windowTitle.hOffset, windowTitle.vOffset + 2);
	}
}

function toggleWindowState()
{
	switch(preferences.windowState.value)
	{
		case "Expanded":
			windowToggle.src = "Resources/Images/Expand.png";
			windowToggle.tooltip = "Expand Window";
			shortcutList.visible = false;
			mainPanel.visible = false;
			pageBackButton.visible = false;
			pageCount.visible = false;
			pageForwardButton.visible = false;
			preferences.windowState.value = "Collapsed";
			horizontalScrollbar.visible = false;
			break;
		case "Collapsed":
			windowToggle.src = "Resources/Images/Collapse.png";
			windowToggle.tooltip = "Collapse Window";
			shortcutList.visible = true;
			mainPanel.visible = true;
			updatePageButtons();
			horizontalScrollbar.visible = true;
			preferences.windowState.value = "Expanded";
			break;
	}
}